#ifndef OBJECTS_DETECTION_TESTOBJECTSDETECTIONAPPLICATION_HPP
#define OBJECTS_DETECTION_TESTOBJECTSDETECTIONAPPLICATION_HPP

#include <boost/program_options.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>
#include <string>

namespace doppia {
// forward declarations
class AbstractVideoInput;
class ImagesFromDirectory;
}
namespace objects_detection {

// forward declaration
class FakeAbstractVideoInput;

class TestObjectsDetectionApplication
{

protected:
    // processing modules
    boost::shared_ptr<FakeAbstractVideoInput> video_input_p; // dummy definition
    boost::scoped_ptr<doppia::ImagesFromDirectory> directory_input_p;

public:
    static boost::program_options::options_description get_args_options();

    std::string get_application_title() const;

    TestObjectsDetectionApplication();
    ~TestObjectsDetectionApplication();

    int main(int argc, char *argv[]);

    boost::program_options::variables_map parse_arguments(int argc, char *argv[]);

    void setup_problem(const boost::program_options::variables_map &options);

    void compute_solution();

protected:

    bool should_save_detections;
};


} // end of namespace objects_detection

#endif // OBJECTS_DETECTION_TESTOBJECTSDETECTIONAPPLICATION_HPP
